<?php

namespace Ems\portalGestor\Controller;

use Ems\portalGestor\Service\AlteSalarioService;
use Ems\portalGestor\Util\ExpectedException;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\{ Error, Message };

class AlteSalarioController {

    public function __construct(
        AlteSalarioService  $alteSalarioService
    ) {
        $this->alteSalarioService = $alteSalarioService;
    }

    public function getAltesalario(
        Request\Filter $request,
        Response $response
    ) {
        try {
            $row = $request->getParameters();

            $nrOrg     = (int) $row['NRORG'];
            $nrVinculo = $row['NRVINCULOM'] ?? null;

            $alteSalario = $this->alteSalarioService->getAltesalario(
                $nrOrg, $nrVinculo
            );

            $response->addDataSet(new DataSet('data', $alteSalario));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode(), $e->getTrace()));
        }
    }

}
