create or replace TRIGGER TRILHAUDIT_INSPECPROD
BEFORE INSERT OR UPDATE OR DELETE
ON INSPECPROD FOR EACH ROW
DECLARE
   V_NRSEQTRILHA  NUMBER(10);
   V_NMPRODUTO    VARCHAR2(50);
   V_TIPOPROC     VARCHAR2(50);
   V_NMINSPECAO   VARCHAR2(200);
   V_ITEMALTERADO VARCHAR2(1000);
   V_NEWDESC      VARCHAR2(1000);
   V_OLDDESC      VARCHAR2(1000);
   V_CDOPERADOR   VARCHAR2(12);
   V_CLIENT_INFO  VARCHAR2(64);
   V_EXISTEPROD    VARCHAR2(100);
   V_DSREMOTEADDR VARCHAR2(15);
   V_DSREMOTEHOST VARCHAR2(15);
   V_DSSERVERRDM  VARCHAR2(20);
   V_DSSERVMETHOD VARCHAR2(30);
   V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_ITEMALTERADO := '';
   V_NEWDESC      := '';
   V_OLDDESC      := '';

   --NMUSUARIO(V_NMOPERADOR);
   --DBMS_APPLICATION_INFO.READ_CLIENT_INFO(V_CLIENT_INFO);
   --V_CDOPERADOR := SUBSTR(V_CLIENT_INFO,45,12);

   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   V_CDOPERADOR := V_DSREMOTEOPER;
   --RAISE_APPLICATION_ERROR(-20405,V_NMOPERADOR||'***'||V_CDOPERADOR||'***'||V_DSREMOTEOPER, TRUE);
   IF INSERTING THEN

      IF :NEW.IDPROCPROD = 'A' THEN
         V_TIPOPROC := 'Produto Acabado';
      ELSIF :NEW.IDPROCPROD = 'M' THEN
         V_TIPOPROC := 'Matria Prima';
      ELSIF :NEW.IDPROCPROD = 'P' THEN
         V_TIPOPROC := 'Produto em Processo';
      ELSIF :NEW.IDPROCPROD = 'E' THEN
         V_TIPOPROC := 'Material de Embalagem';
      ELSE
         V_TIPOPROC := 'No se Aplica';
      END IF;

      BEGIN
         SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
           INTO V_NRSEQTRILHA
           FROM TRILHAUDIT;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
         V_NRSEQTRILHA := 0;
      END;

      
      BEGIN
         SELECT NMPRODUTO
           INTO V_NMPRODUTO
           FROM PRODUTO
          WHERE CDPRODUTO = :NEW.CDPRODUTO;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          V_NMPRODUTO := NULL;
      END;

      BEGIN
         SELECT NMINSPECAO
           INTO V_NMINSPECAO
           FROM INSPECAO
          WHERE CDINSPECAO = :NEW.CDINSPECAO;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
          V_NMINSPECAO := NULL;
      END;

      BEGIN
         SELECT MAX(CDINSPECAO)
           INTO V_EXISTEPROD
           FROM INSPECPROD
          WHERE CDPRODUTO   = :NEW.CDPRODUTO
            AND IDPROCPROD  = :NEW.IDPROCPROD
            AND NRSEQINSPRO = :NEW.NRSEQINSPRO
            AND CDINSPECAO  = :NEW.CDINSPECAO;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
         V_EXISTEPROD := NULL;
      END;

      IF V_EXISTEPROD IS NULL THEN
         V_ITEMALTERADO :=  'Insero do produto ' || V_NMPRODUTO || ' - Processo ' || V_TIPOPROC || ', ' || 'Analise ' || V_NMINSPECAO;
      ELSE
         V_ITEMALTERADO :=  'Insero da Analise ' || V_NMINSPECAO || ' - Processo ' || V_TIPOPROC || ', ' || 'Produto ' || V_NMPRODUTO;
      END IF;

      INSERT INTO TRILHAUDIT
         (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
      VALUES
         (V_NRSEQTRILHA, :NEW.CDPRODUTO, :NEW.IDPROCPROD, 'I', SYSDATE, NULL, 'Insero do produto ' || V_NMPRODUTO, V_CDOPERADOR, V_ITEMALTERADO);

   ELSIF DELETING THEN

      IF :NEW.IDPROCPROD = 'A' THEN
         V_TIPOPROC := 'Produto Acabado';
      ELSIF :NEW.IDPROCPROD = 'M' THEN
         V_TIPOPROC := 'Matria Prima';
      ELSIF :NEW.IDPROCPROD = 'P' THEN
         V_TIPOPROC := 'Produto em Processo';
      ELSIF :NEW.IDPROCPROD = 'E' THEN
         V_TIPOPROC := 'Material de Embalagem';
      ELSE
         V_TIPOPROC := 'No se Aplica';
      END IF;

      BEGIN
         SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
           INTO V_NRSEQTRILHA
           FROM TRILHAUDIT;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
         V_NRSEQTRILHA := 0;
      END;

      BEGIN
         SELECT NMPRODUTO
           INTO V_NMPRODUTO
           FROM PRODUTO
          WHERE CDPRODUTO = :OLD.CDPRODUTO;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          V_NMPRODUTO := NULL;
      END;

      BEGIN
         SELECT NMINSPECAO
           INTO V_NMINSPECAO
           FROM INSPECAO
          WHERE CDINSPECAO = :OLD.CDINSPECAO;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          V_NMINSPECAO := NULL;
      END;

      V_ITEMALTERADO :=  'Excluso de Analise ' || V_NMINSPECAO || ' - Processo ' || V_TIPOPROC;

      INSERT INTO TRILHAUDIT
         (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
      VALUES
         (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDPROCPROD, 'E', SYSDATE, NULL, 'Excluso da Analise: ' || V_NMINSPECAO, V_CDOPERADOR, V_ITEMALTERADO);

   ELSIF UPDATING THEN
      IF (:NEW.CDPRODUTO <> :OLD.CDPRODUTO) THEN
         BEGIN
            SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
              INTO V_NRSEQTRILHA
              FROM TRILHAUDIT;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NRSEQTRILHA := 0;
         END;

         V_ITEMALTERADO :=  'Produto ';

         INSERT INTO TRILHAUDIT
            (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
         VALUES
            (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDPROCPROD, 'A', SYSDATE, :OLD.CDPRODUTO, :NEW.CDPRODUTO, V_CDOPERADOR, V_ITEMALTERADO);
      END IF;

      IF (:NEW.CDINSPECAO <> :OLD.CDINSPECAO) THEN
         BEGIN
            SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
              INTO V_NRSEQTRILHA
              FROM TRILHAUDIT;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NRSEQTRILHA := 0;
         END;

         V_ITEMALTERADO := 'Analise ';

         INSERT INTO TRILHAUDIT
            (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
         VALUES
            (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDPROCPROD, 'A', SYSDATE, :OLD.CDINSPECAO, :NEW.CDINSPECAO, V_CDOPERADOR, V_ITEMALTERADO);
      END IF;

      IF (:NEW.NRSEQINSPRO <> :OLD.NRSEQINSPRO) THEN
         BEGIN
            SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
              INTO V_NRSEQTRILHA
              FROM TRILHAUDIT;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NRSEQTRILHA := 0;
         END;

         BEGIN
            SELECT NMINSPECAO
              INTO V_NMINSPECAO
              FROM INSPECAO
             WHERE CDINSPECAO = :NEW.CDINSPECAO;
         EXCEPTION
           WHEN NO_DATA_FOUND THEN
            V_NMINSPECAO := NULL;
         END;

         V_ITEMALTERADO := 'Cdigo da Analise ' || V_NMINSPECAO;

         INSERT INTO TRILHAUDIT
            (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
         VALUES
            (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDPROCPROD, 'A', SYSDATE, :OLD.NRSEQINSPRO, :NEW.NRSEQINSPRO, V_CDOPERADOR, V_ITEMALTERADO);
      END IF;

      IF (:NEW.CDSETOR <> :OLD.CDSETOR) THEN
         BEGIN
            SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
              INTO V_NRSEQTRILHA
              FROM TRILHAUDIT;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NRSEQTRILHA := 0;
         END;

         BEGIN
            SELECT NMSETOR
              INTO V_NEWDESC
              FROM SETOR
             WHERE CDSETOR = :NEW.CDSETOR;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NEWDESC := '';
         END;

         BEGIN
            SELECT NMSETOR
              INTO V_OLDDESC
              FROM SETOR
             WHERE CDSETOR = :OLD.CDSETOR;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_OLDDESC := '';
         END;

         BEGIN
            SELECT NMINSPECAO
              INTO V_NMINSPECAO
              FROM INSPECAO
             WHERE CDINSPECAO = :NEW.CDINSPECAO;
         EXCEPTION
           WHEN NO_DATA_FOUND THEN
            V_NMINSPECAO := NULL;
         END;

         V_ITEMALTERADO := 'Setor da Analise ' || V_NMINSPECAO;

         INSERT INTO TRILHAUDIT
            (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
         VALUES
            (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDPROCPROD, 'A', SYSDATE, V_OLDDESC, V_NEWDESC, V_CDOPERADOR, V_ITEMALTERADO);
      END IF;

      IF (:NEW.IDPROCPROD <> :OLD.IDPROCPROD) THEN
         BEGIN
            SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
              INTO V_NRSEQTRILHA
              FROM TRILHAUDIT;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NRSEQTRILHA := 0;
         END;

         IF :NEW.IDPROCPROD = 'A' THEN
            V_NEWDESC := 'Produto Acabado';
         ELSIF :NEW.IDPROCPROD = 'M' THEN
            V_NEWDESC := 'Matria Prima';
         ELSIF :NEW.IDPROCPROD = 'P' THEN
            V_NEWDESC := 'Produto em Processo';
         ELSIF :NEW.IDPROCPROD = 'E' THEN
            V_NEWDESC := 'Material de Embalagem';
         ELSE
            V_NEWDESC := 'No se Aplica';
         END IF;

         IF :OLD.IDPROCPROD = 'A' THEN
            V_OLDDESC := 'Produto Acabado';
         ELSIF :OLD.IDPROCPROD = 'M' THEN
            V_OLDDESC := 'Matria Prima';
         ELSIF :OLD.IDPROCPROD = 'P' THEN
            V_OLDDESC := 'Produto em Processo';
         ELSIF :OLD.IDPROCPROD = 'E' THEN
            V_OLDDESC := 'Material de Embalagem';
         ELSE
            V_OLDDESC := 'No se Aplica';
         END IF;

         BEGIN
            SELECT NMPRODUTO
              INTO V_NMPRODUTO
              FROM PRODUTO
             WHERE CDPRODUTO = :NEW.CDPRODUTO;
         EXCEPTION
           WHEN NO_DATA_FOUND THEN
             V_NMPRODUTO := NULL;
         END;

         V_ITEMALTERADO := 'Processo do Produto ' || V_NMPRODUTO;

         INSERT INTO TRILHAUDIT
            (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
         VALUES
            (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDPROCPROD, 'A', SYSDATE, V_OLDDESC, V_NEWDESC, V_CDOPERADOR, V_ITEMALTERADO);
      END IF;

      IF (:NEW.IDSTATUSINSPEC <> :OLD.IDSTATUSINSPEC) THEN
         BEGIN
            SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
              INTO V_NRSEQTRILHA
              FROM TRILHAUDIT;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NRSEQTRILHA := 0;
         END;

         BEGIN
            SELECT NMINSPECAO
              INTO V_NMINSPECAO
              FROM INSPECAO
             WHERE CDINSPECAO = :NEW.CDINSPECAO;
         EXCEPTION
           WHEN NO_DATA_FOUND THEN
            V_NMINSPECAO := NULL;
         END;

         V_ITEMALTERADO := 'Status da Analise ' || V_NMINSPECAO;

         INSERT INTO TRILHAUDIT
            (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
         VALUES
            (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDPROCPROD, 'A', SYSDATE, DECODE(:OLD.IDSTATUSINSPEC, 'I', 'Inativo', 'Ativo'), DECODE(:NEW.IDSTATUSINSPEC, 'I', 'Inativo', 'Ativo'), V_CDOPERADOR, V_ITEMALTERADO);
      END IF;
      IF (:NEW.CDORDEMINSPEC <> :OLD.CDORDEMINSPEC) THEN
         BEGIN
            SELECT NVL(MAX(NRSEQTRILHA) ,0) + 1 AS NRSEQTRILHA
              INTO V_NRSEQTRILHA
              FROM TRILHAUDIT;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
            V_NRSEQTRILHA := 0;
         END;

         BEGIN
            SELECT NMINSPECAO
              INTO V_NMINSPECAO
              FROM INSPECAO
             WHERE CDINSPECAO = :NEW.CDINSPECAO;
         EXCEPTION
           WHEN NO_DATA_FOUND THEN
            V_NMINSPECAO := NULL;
         END;

         V_ITEMALTERADO := 'Ordem da Analise ' || V_NMINSPECAO;

         INSERT INTO TRILHAUDIT
            (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
         VALUES
            (V_NRSEQTRILHA, :OLD.CDPRODUTO, :OLD.IDPROCPROD, 'A', SYSDATE, :OLD.CDORDEMINSPEC, :NEW.CDORDEMINSPEC, V_CDOPERADOR, V_ITEMALTERADO);
      END IF;
   END IF;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('TRILHAUDIT_INSPECPROD','6.25.xxx'); END;
/
